org.apache.catalina.filters

## Class WebdavFixFilter

- java.lang.Object
- - org.apache.catalina.filters.WebdavFixFilter

- All Implemented Interfaces:
    Filter

      public class WebdavFixFilter
      extends Object
      implements Filter

  Filter that attempts to force MS WebDAV clients connecting on port 80 to use a WebDAV client that actually works. Other workarounds that might help include:
  - Specifying the port, even if it is port 80, when trying to connect.
  - Cancelling the first authentication dialog box and then trying to reconnect.
  Generally each different version of the MS client has a different set of problems.

  TODO: Update this filter to recognise specific MS clients and apply the appropriate workarounds for that particular client

  As a filter, this is configured in web.xml like any other Filter. You usually want to map this filter to whatever your WebDAV servlet is mapped to.

  In addition to the issues fixed by this Filter, the following issues have also been observed that cannot be fixed by this filter. Where possible the filter will add an message to the logs.

  XP x64 SP2 (MiniRedir Version 3790)

  - Only connects to port 80
  - Unknown issue means it doesn't work

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static StringManager` | `sm`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WebdavFixFilter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `destroy()` Called by the web container to indicate to a filter that it is being taken out of service.
    `void` | `doFilter(ServletRequest request, ServletResponse response, FilterChain chain)` Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.
    `void` | `init(FilterConfig filterConfig)` Called by the web container to indicate to a filter that it is being placed into service.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sm

          protected static final StringManager sm

  - ### Constructor Detail

    - #### WebdavFixFilter

          public WebdavFixFilter()

  - ### Method Detail

    - #### init

          public void init(FilterConfig filterConfig)
                    throws ServletException

      Description copied from interface: `javax.servlet.Filter`
      Called by the web container to indicate to a filter that it is being placed into service. The servlet container calls the init method exactly once after instantiating the filter. The init method must complete successfully before the filter is asked to do any filtering work.

      The web container cannot place the filter into service if the init method either:

      - Throws a ServletException
      - Does not return within a time period defined by the web container
      Specified by:
        `init` in interface `Filter`
      Parameters:
        `filterConfig` - The configuration information associated with the filter instance being initialised
      Throws:
        `ServletException` - if the initialisation fails

    - #### destroy

          public void destroy()

      Description copied from interface: `javax.servlet.Filter`
      Called by the web container to indicate to a filter that it is being taken out of service. This method is only called once all threads within the filter's doFilter method have exited or after a timeout period has passed. After the web container calls this method, it will not call the doFilter method again on this instance of the filter.
      This method gives the filter an opportunity to clean up any resources that are being held (for example, memory, file handles, threads) and make sure that any persistent state is synchronized with the filter's current state in memory.
      Specified by:
        `destroy` in interface `Filter`

    - #### doFilter

          public void doFilter(ServletRequest request,
                      ServletResponse response,
                      FilterChain chain)
                        throws IOException,
                               ServletException

      Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.
      Specified by:
        `doFilter` in interface `Filter`
      Parameters:
        `request` - The request to process
        `response` - The response associated with the request
        `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
      Throws:
        `IOException` - if an I/O error occurs during this filter's processing of the request
        `ServletException` - if the processing fails for any other reason

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.